#Kathryn Rath

def ask_quit():
    answer = raw_input("Are you sure you want to end the game? You cannot save. Type yes or no: ")
    print " "
    return answer

def ask_again():
    answer = raw_input("Would you like to play again? Type yes or no: ")
    print " "
    return answer

class Node:
    def __init__(self, name, description):
        self.name = name
        self.description = description
        self.items = []

    def has_items(self, item):
        self.items.append(item)

class Edge:
    def __init__(self, n_from, order, n_to, description, health, constraint = None):
        self.n_from = n_from
        self.order = order.split(",")
        self.n_to = n_to
        self.health = eval(health)
        self.constraint = constraint
        self.description = description

class Item:
    def __init__(self, location, name, name2, description, weight):
        self.location = location
        self.name = name
        self.name2 = name2
        self.description = description
        self.weight = weight

class Constraint:
    def __init__(self, name, item, location):
        self.name = name
        self.item = item
        self.location = location

class Engine:
    def __init__(self, filename):
        self.filename = filename
        self.initial_state = None
        self.nodes = []
        self.edges = []
        self.items = []
        self.constraints=[]

    def load(self):
        fp = open(self.filename)
        for line in fp:
            line = line.replace("\n", "")
            line = line.split("::")
            if line[0]=="constraint":
                constraint = Constraint(line[1], line[2], line[3])
                self.constraints.append(constraint)
            if line[0] == "node":
                node = Node(line[1], line[2])
                self.nodes.append(node)
            if line[0] == "edge":
                if len(line) == 7:
                    edge = Edge(line[1], line[2], line[3], line[4], line[5], line[6])
                    self.edges.append(edge)
                else:
                    edge = Edge(line[1], line[2], line[3], line[4], line[5])
                    self.edges.append(edge)
            if line[0] == "object":
                item = Item(line[1], line[2], line[3], line[4], line[5])
                self.items.append(item)
                for item in self.items:
                    for node in self.nodes:
                        if item.location == node.name:
                            if item not in node.items:
                                node.has_items(item)

    def play(self):
        self.health = 10
        playing = True
        place = self.nodes[0]
        backpack = []
        while playing:
            print(place.description)
            print " "
            if len(place.items) is not 0:
                print("There are a few interesting items here: ")
                for item in place.items:
                    print(item.name)
                print " "
            command = raw_input("Command> ")
            print " "
            command2 = command.split()
            move = False
            if self.health <= 0:
                print "You ran out of health! You are dead."
                answer3 = ask_again()
                if answer3 == "yes":
                    self.play()
                elif answer3 == "no":
                    print "Hope you enjoyed playing! Bye!"
                    playing = False
            if command2[0] == "grab":
                for item in place.items:
                    if item.name==command2[1] and item not in backpack:
                        backpack.append(item)
                        place.items.remove(item)
                        print("You now have " + item.name + " in your backpack!")
                        print " "
                        move = True
            elif command2[0] == "drop":
                for item in backpack:
                    if item.name == command2[1] and item not in place.items:
                        place.items.append(item)
                        backpack.remove(item)
                        print("You have dropped " + item.name)
                        print " "
                        move = True
            elif command2[0]=="look":
                for item in backpack:
                    if item.name == command2[1]:
                        print item.description
                        print " "
                        move = True
                for item in place.items:
                    if item.name == command2[1]:
                        print item.description
                        print " "
                        move = True
            elif command == "quit":
                answer = ask_quit()
                if answer == "yes":
                    answer2 = ask_again()
                    if answer2 == "yes":
                        self.play()
                    else:
                        print "Hope you enjoyed playing! Bye!"
                        playing = False
            elif command == "health":
                print self.health
                print " "
            else:
                for edge in self.edges:
                    if command in edge.order and place.name==edge.n_from and move == False:
                        for node in self.nodes:
                            if node.name == edge.n_to:
                                if edge.constraint is None:
                                    print(edge.description)
                                    print " "
                                    place = node
                                    move = True
                                    self.health = self.health + edge.health 
                                    break
                                elif edge.constraint is not None:
                                    for constraint in self.constraints:
                                        if constraint.name == edge.constraint:
                                            for item in backpack:
                                                if item.name == constraint.item:
                                                    print(edge.description)
                                                    print " "
                                                    place = node
                                                    move = True
                                                    self.health = self.health + edge.health
                                                    break
                                    if move == False:
                                        print("You need an item you don't have to do that.")
                                        print " "
                                        move = True
            if move == False:
                print "I don't know what you're trying to do. Please try a different command."
                print " "
                    
                


game = Engine("apartment_escape.txt")
game.load()
game.play()

